import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["placeholder", "skeleton", "bgStyles", "spinner", "errorIcon", "errorText", "onError", "onLoad", "sources", "alt"];
import { cloneElement, useState, useEffect, useRef, useCallback } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { htmlImgProps } from './types.js';
import { BASE_CLASS, BASE_CLASS_FIGURE, CLASS_PLACEHOLDER, CLASS_SKELETON, CLASS_IMAGE, CLASS_SPINNER, CLASS_ERROR } from './settings.js';
import ErrorImage from './ErrorImage.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var AtomImage = function AtomImage(_ref) {
  var placeholder = _ref.placeholder,
      skeleton = _ref.skeleton,
      bgStyles = _ref.bgStyles,
      Spinner = _ref.spinner,
      errorIcon = _ref.errorIcon,
      errorText = _ref.errorText,
      onError = _ref.onError,
      onLoad = _ref.onLoad,
      _ref$sources = _ref.sources,
      sources = _ref$sources === void 0 ? [] : _ref$sources,
      alt = _ref.alt,
      imgProps = _objectWithoutPropertiesLoose(_ref, _excluded);

  var imageRef = useRef();

  var _useState = useState(true),
      loading = _useState[0],
      setLoading = _useState[1];

  var _useState2 = useState(false),
      error = _useState2[0],
      setError = _useState2[1];

  var src = imgProps.src;
  useEffect(function () {
    setLoading(true);
    setError(false);
  }, [src, setLoading, setError]);
  var handleLoad = useCallback(function () {
    var _imageRef$current;

    var loadCompleted = imageRef == null ? void 0 : (_imageRef$current = imageRef.current) == null ? void 0 : _imageRef$current.complete;

    if (loadCompleted === true) {
      setLoading(!loadCompleted);
      onLoad && onLoad();
    }
  }, [onLoad, setLoading]);
  useEffect(function () {
    handleLoad();
  }, [handleLoad, imageRef]);
  var classNames = cx(BASE_CLASS, "is-" + (loading ? 'loading' : 'loaded'), error && "is-error");
  var classNamesFigure = cx(BASE_CLASS_FIGURE, placeholder && CLASS_PLACEHOLDER, skeleton && CLASS_SKELETON);

  var handleError = function handleError() {
    setLoading(false);
    setError(true);
    onError && onError();
  };

  var figureStyles = {
    backgroundImage: "url(" + (placeholder || skeleton) + ")"
  };
  var SpinnerExtended = Spinner && /*#__PURE__*/cloneElement(Spinner, {
    className: CLASS_SPINNER
  });
  return /*#__PURE__*/_jsxs("div", {
    className: classNames,
    children: [/*#__PURE__*/_jsx("figure", {
      className: classNamesFigure,
      style: !error && (placeholder || skeleton) ? figureStyles : {},
      children: /*#__PURE__*/_jsxs("picture", {
        children: [sources.map(function (source, idx) {
          return /*#__PURE__*/_jsx("source", _extends({}, source), idx);
        }), /*#__PURE__*/_jsx("img", _extends({
          className: CLASS_IMAGE,
          onLoad: handleLoad,
          onError: handleError,
          ref: imageRef,
          alt: alt
        }, imgProps))]
      })
    }), !error && loading && SpinnerExtended, error && /*#__PURE__*/_jsx(ErrorImage, {
      className: CLASS_ERROR,
      icon: errorIcon,
      text: errorText
    })]
  });
};

AtomImage.displayName = 'AtomImage';
export default AtomImage;